summaryrefslogtreecommitdiffstats
path: root/bin/git-debian-check.d/commit_release-commits-have-release-tags.sh
diff options
context:
space:
mode:
Diffstat (limited to 'bin/git-debian-check.d/commit_release-commits-have-release-tags.sh')
-rwxr-xr-xbin/git-debian-check.d/commit_release-commits-have-release-tags.sh38
1 files changed, 38 insertions, 0 deletions
diff --git a/bin/git-debian-check.d/commit_release-commits-have-release-tags.sh b/bin/git-debian-check.d/commit_release-commits-have-release-tags.sh
new file mode 100755
index 0000000..cdc2d98
--- /dev/null
+++ b/bin/git-debian-check.d/commit_release-commits-have-release-tags.sh
@@ -0,0 +1,38 @@
+#!/bin/sh
+
+# source-tools - Git extra utilities
+# Copyright (C) 2014-2016 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+set -e
+
+echo -n " * (\033[0;32m${BRANCH}\033[0m) release commits have release tags..."
+
+COMMITS="$(git log --no-abbrev-commit ${BRANCH} -- | grep -B4 -E "(Releasing|Adding) ${BRANCH} version [0-9].*.$" | awk '/^commit / { print $2 }')"
+
+for COMMIT in ${COMMITS}
+do
+ VERSION="$(git show --no-patch --no-renames --pretty=format:%B ${COMMIT} | head -n1 | awk -Fversion\ '{ print $2 }' | sed -e 's|.$||')"
+ TAG="$(echo ${VERSION} | sed -e 's|:|%|g' -e 's|~|_|g')"
+ ID="$(git show --no-abbrev-commit --no-patch --no-renames ${BRANCH}/${TAG} | awk '/^commit / { print $2 }')"
+
+ if [ "${ID}" != "${COMMIT}" ]
+ then
+ echo " \033[1;31mno\033[0m."
+ echo "E: commit ${COMMIT} has no release tag."
+ fi
+done
+
+echo " \033[1;32myes\033[0m."